; inc_ConfigTools.ahk
; has labels and functions for configuring language tools.

InitLangTools:
; sets tools from ini file or asks user for directroy if not tools not found
    IniRead, gToolPath, %kIniFile%, %kToolSection%, %kToolPathKey%  ; get stuff from ini file
    IfNotExist %gToolPath%\%kCompileTool%.exe     	; if gToolPath does not produce good tools,
        gosub ConfigFirstUse                    	; then ask for a new folder, etc.
    IfNotExist %gToolPath%\%kInterpreterTool%.exe
        gosub ConfigFirstUse
    return

ConfigFirstUse:
; guides user through first-time jIDEE configuration.
	MsgBox, 4160, %kConfigFirstUseMsgTitle%, %kConfigFirstUseMsgTxt%			; ok, info icon, system modal
	gosub SetJavaToolDir
	gosub InitNewRootName
	return	

SetJavaToolDir:
; prompt for a directory with Java tools and don't stop until we get one.
; note: canceling will quit the app
    Loop
    {
		IfExist, %A_ProgramFiles%\Java\
			gTempDirName = %A_ProgramFiles%\Java\
		Else
			gTempDirName = %A_ProgramFiles%
		; prompt for and set new working dir, update (rebuild) file lists and update working dir text on main gui
        Gui +OwnDialogs  ; Forces user to dismiss the following dialog before using main window.
        FileSelectFolder, gTempDirName, *%gTempDirName%, 0, %kSetJDKTools%
        if not gTempDirName  ; The user canceled the dialog.
        	gosub Quit
        IfExist %gTempDirName%\bin\%kCompileTool%.exe
        {
            IfExist %gTempDirName%\bin\%kInterpreterTool%.exe
            {
                gToolPath = %gTempDirName%\bin		; set tool path
                IniWrite, %gToolPath%, %kIniFile%, %kToolSection%, %kToolPathKey% 	; save new path and tool names to ini file
                break   ; terminate the loop
            }
        }
	}
    return

InitNewRootName:
; prompt for new root dir, set gRootDir to new directory
; note: canceling will quit the app
; TODO move GUI sting to GUI string files
	Gui +OwnDialogs	; Forces user to dismiss the following dialog before using main window.
	FileSelectFolder, gTempDirName, *%gRootDir%, 1, %kSetRootFolderWizard%
	if not gTempDirName		; The user canceled the dialog.
		gosub Quit
	; if user selected a root drive, give message and return
	SplitPath, gTempDirName, projectRootName,,,, 	; if user selected a root drive, projectRootName will be blank 
	if projectRootName
		gRootDir = %gTempDirName%
	else
	{
		msgbox Root drives cannot be used as project roots.`nSelect a different folder as your project root.
		;gosub ChangeRootDir			; recurse.
		gosub InitNewRootName			; recurse.
	}
	return
